#pragma once

#include "BaseEvent.h"
#include <atltypes.h>

class CComponent;
class CPropertyChangeEvent
{
public:
	enum
	{
		MAX_PROPERTY = 256,
	};
	CPropertyChangeEvent(CComponent* pSource, LPCTSTR pszcPropertyName)
	{
		ATLASSERT(pSource && _tcslen(pszcPropertyName) > 0);
		m_pSource = pSource;
		_tcsncpy(m_szPropertyName, pszcPropertyName, MAX_PROPERTY);
	}
	~CPropertyChangeEvent() {}
	
	BOOL IsProperty(LPCTSTR propertyValue)
	{
		return _tcscmp(propertyValue, m_szPropertyName) == 0;
	}

	CComponent* m_pSource;
	TCHAR m_szPropertyName[MAX_PROPERTY];
};

interface IPropertyChangedListener : public IBaseListener
{
public:
	virtual ~IPropertyChangedListener() {}
	virtual void OnPropertyChanged(CPropertyChangeEvent* pPropertyChangedEvent) = 0;
};